package javax.swing.text.html.parser;

import sun.awt.AppContext;
import java.util.Hashtable;
import java.util.BitSet;
import java.io.Serializable;

public final class Element implements DTDConstants, Serializable
{
    public int index;
    public String name;
    public boolean oStart;
    public boolean oEnd;
    public BitSet inclusions;
    public BitSet exclusions;
    public int type;
    public ContentModel content;
    public AttributeList atts;
    public Object data;
    private static final Object MAX_INDEX_KEY;
    static Hashtable<String, Integer> contentTypes;
    
    Element() {
        this.type = 19;
    }
    
    Element(String name, int n) {
        this.type = 19;
        this.name = name;
        this.index = n;
        if (n > getMaxIndex()) {
            AppContext.getAppContext().put(Element.MAX_INDEX_KEY, Integer.valueOf(n));
        }
    }
    
    static int getMaxIndex() {
        Integer n = (Integer)AppContext.getAppContext().get(Element.MAX_INDEX_KEY);
        return (n != null) ? ((int)n) : 0;
    }
    
    public String getName() {
        return this.name;
    }
    
    public boolean omitStart() {
        return this.oStart;
    }
    
    public boolean omitEnd() {
        return this.oEnd;
    }
    
    public int getType() {
        return this.type;
    }
    
    public ContentModel getContent() {
        return this.content;
    }
    
    public AttributeList getAttributes() {
        return this.atts;
    }
    
    public int getIndex() {
        return this.index;
    }
    
    public boolean isEmpty() {
        return this.type == 17;
    }
    
    @Override
    public String toString() {
        return this.name;
    }
    
    public AttributeList getAttribute(String anObject) {
        AttributeList list = this.atts;
        while (list != null) {
            if (list.name.equals(anObject)) {
                return list;
            }
            list = list.next;
        }
        return null;
    }
    
    public AttributeList getAttributeByValue(String o) {
        AttributeList list = this.atts;
        while (list != null) {
            if (list.values != null && list.values.contains(o)) {
                return list;
            }
            list = list.next;
        }
        return null;
    }
    
    public static int name2type(String key) {
        Integer n = (Integer)Element.contentTypes.get(key);
        return (n != null) ? ((int)n) : 0;
    }
    
    static {
        MAX_INDEX_KEY = new Object();
        (Element.contentTypes = new Hashtable()).put("CDATA", Integer.valueOf(1));
        Element.contentTypes.put("RCDATA", Integer.valueOf(16));
        Element.contentTypes.put("EMPTY", Integer.valueOf(17));
        Element.contentTypes.put("ANY", Integer.valueOf(19));
    }
}
